﻿final class Search implements Runnable {
	// ...
	private int search(int depth, int alpha, int beta, int ply) {
		// ...
		// Inicialização.
		int bestValue = -Value.INFINITE;
		int searchedMoves = 0;
		boolean isCheck = position.isCheck();

		// Gera os movimentos possíveis para a configuração "position"
		//  e faz a busca até a profundidade "depth".
		MoveList<MoveEntry> moves = moveGenerators[ply].getMoves(position, depth, isCheck);
		for (int i = 0; i < moves.size; ++i) {
		  int move = moves.entries[i].move;
		  int value = bestValue;

		  position.makeMove(move);
		  if (!position.isCheck(Color.opposite(position.activeColor))) {
			++searchedMoves;
			// Faz a busca recursivamente.
			value = -search(depth - 1, -beta, -alpha, ply + 1);
		  }
		  position.undoMove(move);

		  // Se receber um comando para parar, devolve o melhor valor encontrado.
		  if (abort) {
			return bestValue;
		  }

		  // Poda.
		  if (value > bestValue) {
			bestValue = value;

			// Se encontrar um valor melhor, atualiza.
			if (value > alpha) {
			  alpha = value;
			  savePV(move, pv[ply + 1], pv[ply]);

			  // Verifica se o valor é
			  // maior que beta.
			  if (value >= beta) {
				// Se for maior exclui este.
				break;
			  }
			}
		  }
		}
	}
	// ...
}
