﻿final class Evaluation {
    // ...
    // Calcula a pontuação da posição.
    int evaluate(Position position) {
        assert position != null;

        // Inicialização.
        int myColor = position.activeColor;
        int oppositeColor = Color.opposite(myColor);
        int value = 0;

        // Avaliação do material.
        int materialScore = (evaluateMaterial(myColor, position) - evaluateMaterial(oppositeColor, position))
            * materialWeight / MAX_WEIGHT;
        value += materialScore;

        // Avaliação da mobilidade.
        int mobilityScore = (evaluateMobility(myColor, position) - evaluateMobility(oppositeColor, position))
            * mobilityWeight / MAX_WEIGHT;
        value += mobilityScore;

        value += TEMPO;

        assert Math.abs(value) < Value.CHECKMATE_THRESHOLD;
        // Devolve a pontuação final.
        return value;
    }

    // ...
}
