﻿final class MoveGenerator {

  // Cria uma lista que armazena os movimentos.
  private final MoveList<MoveEntry> moves = new MoveList<>(MoveEntry.class);

  // Devolve uma lista contendo somente movimentos válidos.
  MoveList<MoveEntry> getLegalMoves(Position position, int depth, boolean isCheck) {
    assert position != null;

    // Uma lista que recebe todos os movimentos possíveis.
    MoveList<MoveEntry> legalMoves = getMoves(position, depth, isCheck);

    int size = legalMoves.size;
    legalMoves.size = 0;

    // Para cada movimento em "legalMoves", executa uma verificação.
    for (int i = 0; i < size; ++i) {
      int move = legalMoves.entries[i].move;

      position.makeMove(move);
      if (!position.isCheck(Color.opposite(position.activeColor))) {
        legalMoves.entries[legalMoves.size++].move = move;
      }
      position.undoMove(move);
    }

    return legalMoves;
  }

  //...
}
