﻿final class MoveGenerator {
  //...

  // Devolve uma lista contendo todos os movimentos possíveis.
  MoveList<MoveEntry> getMoves(Position position, int depth, boolean isCheck) {
    assert position != null;

    moves.size = 0;

    if (depth > 0) { // Gera os movimentos.
      // Armazena na lista "moves" os movimentos possíveis de cada peça
      // na situação da configuração "position".
      addMoves(moves, position);

      // Considera também o movimento de encastelamento.
      if (!isCheck) {
        int square = Bitboard.next(position.pieces[position.activeColor][PieceType.KING].squares);
        addCastlingMoves(moves, square, position);
      }
    } else { // Gera os movimentos relativamente em repouso ou quiescent.

      addMoves(moves, position);

      if (!isCheck) {
        int size = moves.size;
        moves.size = 0;
        for (int i = 0; i < size; ++i) {
          if (Move.getTargetPiece(moves.entries[i].move) != Piece.NOPIECE) {
            moves.entries[moves.size++].move = moves.entries[i].move;
          }
        }
      }
    }

    moves.rateFromMVVLVA();
    moves.sort();

    return moves;
  }

  //...
}
